<?


function datasource_translate( $code )
{ 
 global $FEATURE;

 if ( !$FEATURE["datasource_translate"] ) {
 $dsPrefix = "nodedatasource";
 $prefixLength = strlen( $dsPrefix );
 $offset = 0;
 $ret = "";
 while ( !is_false( $pos1 = strpos($code, "<$dsPrefix " , $offset) ) )
 {
 $pos2 = strpos( $code, ">", $pos1 );
 $start = $pos1+$prefixLength+2;
 $length = $pos2 - $start;
 $dsId = substr( $code, $start, $length );
 if ( is_false( $posEnd = strpos( $code, "</$dsPrefix>", $pos2 ) ) )
 return $ret . substr( $code, $offset );
 $length = $posEnd-$pos2-1;
 $dsTemplate = substr( $code, $pos2+1, $length );
 $length = $pos1-$offset;
 $ret .= substr( $code, $offset, $length );

 unset( $source );
 $source =& SourceFactory::loadSingle( $dsId );
 if ( $source )
 {
 $tr = $source->translate( $source->exportIds(), $dsTemplate );
 $ret .= $tr["value"];
 }

 $offset = $posEnd + 3 + $prefixLength; 
 }
 return $ret.substr( $code, $offset );
 } else {
 return $code;
 }

}


function code_translate($code,$tags,$type,$edit = false,$tagpath = Array(), $mother_type = 'page', $mother_id = 0, $leave_tags = false, $node_id = 0) {

 global $ICO_TPL, $STAG, $STAG_PREFIX, $CONSTRUCTS, $FEATURE, $GENTICS_META, $TAG_PREFIX, $MODULE, $INPAGEEDIT_TAGS, $DO_TAGFILL_BACK, $GENTICS_META_TAG, $T_PAGE;
 
 $tag_prefix_length = strlen($TAG_PREFIX);
 
 $offset = 0;
 
 
 if (!$node_id) {
 if (($mother_type == $T_PAGE || $mother_type == "page") && $mother_id) {
 $sql = "SELECT folder.node_id FROM page, folder WHERE page.folder_id = folder.id AND page.id = '".sqlf_escaped($mother_id)."'";
 $rs = query($sql, 1);
 $node_id = $rs["arr"][0]["node_id"];
 }
 }
 
 
 
 while (!is_false($pos1 = strpos($code,"<$TAG_PREFIX ",$offset))) {
 
 
 $pos2 = strpos($code,">",$pos1);
 
 if (!$pos2) $pos2 = $pos1 + $tag_prefix_length + 1;
 
 $fulltag = substr($code,$pos1, $pos2 - $pos1 + 1);
 $tagname = substr($fulltag, $tag_prefix_length + 2, strlen($fulltag) - ($tag_prefix_length + 3));
 $colonfunction = false;
 if ($colonindex = strpos( $tagname, ':')) {
 $colonfunction = substr( $tagname, $colonindex + 1 );
 if ($colonfunction == "escape") {
 $_tagname = substr($tagname,0,-7);
 } else {
 $_tagname = substr($tagname,0,$colonindex);
 }
 } else {
 $_tagname = $tagname;
 }
 
 
 if ($tagpath[$_tagname]) {
 if ($edit) $tags[$_tagname]["value"] = img("$STAG_PREFIX?do=11&module=$MODULE&img=constr/stop.gif")." <font color=red>Zirkelbezug auf &lt;$TAG_PREFIX $tagname&gt;</font>";
 else $tags[$_tagname]["value"] = "";
 $tags[$_tagname]["auto"] = 1;
 }
 
 
 if (($tags[$_tagname]["unused"] || !isset($tags[$_tagname])) && $FEATURE["page_cleanup_36"]) {
 node_include("cleanup_tags");
 
 $tagbase = find_tag_base($_tagname);
 $pid = 0;
 if ($tags[$tagbase]["unused"] && $tags[$tagbase]["tagtype"] == "content") {
 
 $tid = $tags[$tagbase]["id"];
 $ntags = try_reuse_tag($tid, $tagbase, true, $edit, $node_id);
 if ($ntags) {
 $l = strlen($tagbase);
 foreach($ntags as $tag=>$val) {
 if (substr($tag, 0, $l) != $tagbase) continue;
 
 $tags[$tag] = $val;
 }
 }
 }
 }
 
 
 global $FOUND_TAGS;
 if (is_array($FOUND_TAGS) && $FEATURE["page_cleanup_36"]) {
 node_include("cleanup_tags");
 $tagbase = find_tag_base($_tagname);
 if (!is_system_tag($tagbase)) {
 $FOUND_TAGS[$tagbase] = array("id"=>$tags[$tagbase]["id"], "pub"=>$tags[$tagbase]["pub"], "type"=>$tags[$tagbase]["tagtype"]);
 }
 }
 
 
 $tagpath[$_tagname] = true;
 $tags[$_tagname]["value"] = code_translate($tags[$_tagname]["value"],$tags,$type,$edit,$tagpath, $mother_type, $mother_id, false, $node_id);
 $tagpath[$_tagname] = false;
 
 $tags["$_tagname:escape"]["value"] = addslashes($tags[$_tagname]["value"]);
 $tags["$_tagname:escape"]["auto"] = true;
 
 
 if (!isset($tags[$tagname]) && !$leave_tags) $tags[$tagname] = "";
 
 
 
 if ($FEATURE["dirt3"] && is_array($tags[$_tagname]["deps"])) {
 $dep_type = $mother_type?$mother_type:$type;
 if ($dep_type == "page") $dep_type = T_PAGE;
 else if ($dep_type == "template") $dep_type = T_TEMPLATE;
 else continue;
 $dep_id = ($mother_type)?$mother_id:0;
 
 foreach ($tags[$_tagname]["deps"] as $dep) {
 addEventDependency($dep["ttype"], $dep["id"], $dep["event"]?$dep["event"]:EVENT_ALL, $dep_type, $dep_id, LINKT_TAGPARSER);
 }
 }

 $_currtagarray = & $tags[$tagname];

 if( $colonfunction == "nbsp" ) {
 $_currtagarray = $tags[$_tagname];
 if( strlen( $tags[$_tagname]['value'] ) == 0 ) {
 $_currtagarray['value'] = '&nbsp;';
 $_currtagarray['auto'] = false;
 } else {
 $_currtagarray['value'] = $tags[$_tagname]['value'];
 $_currtagarray['auto'] = false;
 }
 }
 
 
 if ($edit && $_currtagarray["cid"] > 1 && !$_currtagarray["auto"] && ($type == "template" || ($type == "page" && $_currtagarray["pub"] || $type == "obj"))) {
 construct_load();
 $cname = $CONSTRUCTS[$_currtagarray["cid"]];
 $tagicon = $_currtagarray["icon"];
 $button = tag_link($_currtagarray["id"], $type, $tagname, $tagicon, $cname, false, $_currtagarray["cid"], 0, 
 false, true, $_currtagarray["inpageeditable"], $_tagname, $DO_TAGFILL_BACK);
 } else $button = "";
 
 
 if ($_currtagarray["ds"] == false && is_false(strpos($code,"</$TAG_PREFIX $tagname>",$pos1))) {
 
 
 $_poss = strrpos(substr($code,0,$pos1),"<");
 $_posg = strrpos(substr($code,0,$pos1),">");

 
 if ( $_posg === false && $_poss !== false )
 $_posg = -1;
 
 
 if ($_posg < $_poss ) {

 
 if ($INPAGEEDIT_TAGS[$tagname] && isSupereditEnabled(T_PAGE)) {
 $_currtagarray["value"] = $_currtagarray["inpage_prefix"].$button.$_currtagarray["value"].$_currtagarray["inpage_postfix"];
 $code = substr($code,0,$_posg+1)."<$TAG_PREFIX $tagname>".str_replace("<$TAG_PREFIX $tagname>","",substr($code,$_posg+1));
 } else {
 
 $code = substr($code,0,$_posg+1).$_currtagarray["inpage_prefix"].$button.$_currtagarray["inpage_postfix"].substr($code,$_posg+1);
 }
 
 $code = str_replace($fulltag,$_currtagarray["value"],$code);
 } else {
 
 if (isSupereditEnabled(T_PAGE)) {
 $_currtagarray["value"] = $_currtagarray["inpage_prefix"].$button.$_currtagarray["value"].$_currtagarray["inpage_postfix"];
 $code = str_replace($fulltag,$_currtagarray["value"],$code);
 } else
 $code = str_replace($fulltag,$button.$_currtagarray["value"],$code);
 }
 
 } else {
 
 $posdsend = strpos($code,"</$TAG_PREFIX $tagname>",$pos1);
 if (!$posdsend) {
 $posdsend = $pos1 + strlen($fulltag);
 } else
 $posdsend += strlen("</$TAG_PREFIX $tagname>");
 $ds_old = substr($code,$pos1,$posdsend - $pos1);
 $code = str_replace($ds_old,$_currtagarray["inpage_prefix"].$button.$_currtagarray["value"].$tags
 [$tagname]["inpage_postfix"],$code);
 }
 
 $offset = $pos1;

 }
 
 if ( $GENTICS_META && $mother_id )
 {
 $meta = "<meta name=\"$GENTICS_META_TAG\" content=\"Gentics Content.Node(R) by Gentics (http://www.gentics.com/)\" />";
 
 if ( eregi( "<head[^>]*>", $code ) && eregi( "<html>", $code ) && !eregi( "<head[^>]*>\n$meta", $code ) && !strpos($code,$meta))
 {
 $code = eregi_replace( "(<head[^>]*>)", "\\1\n$meta", $code );
 }
 
 
 





 
 }
 $code = datasource_translate( $code );
 return $code;
 
}

?>
