<?


function cmd_create_workflow($name, $desc, $o_type = 0) {
 global $USER_ID, $TIME, $W_CREATE, $T_WORKFLOW;

 $sql = "INSERT INTO workflow (name, description, o_type, creator, editor, cdate, edate) VALUES (\"".sqlslashes($name)."\",\"".sqlslashes($desc)."\",".sqlf_tl_num($o_type).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($TIME).")";
 $rs = query($sql);

 logcmd($W_CREATE, $T_WORKFLOW, $rs["iid"], 0, "cmd_create_workflow");
 return $rs["iid"];
}


function cmd_update_workflow($id, $name, $desc, $o_type = 0) {
 global $USER_ID, $TIME, $W_EDIT, $T_WORKFLOW;

 $sql = "UPDATE workflow SET name = \"".sqlslashes($name)."\", description = \"".sqlslashes($desc)."\", o_type = ".sqlf_tl_num($o_type).", editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME)." WHERE id = ".sqlf_tl_num($id);
 query($sql);

 logcmd($W_EDIT, $T_WORKFLOW, $id, 0, "cmd_update_workflow");
}


function cmd_delete_workflow($id) {
 global $W_DEL, $T_WORKFLOW;

 $sql = "DELETE FROM workflow WHERE id = ".sqlf_tl_num($id);
 query($sql);

 $sql = "SELECT id FROM workflowlink WHERE workflow_id = ".sqlf_tl_num($id);
 $rs = query($sql);

 while (list($key, $val) = each($rs["arr"])) {
 cmd_remove_workflowlink($val["id"]);
 }

 $sql = "SELECT id FROM triggerevent WHERE workflow_id = ".sqlf_tl_num($id)." AND reaction_id = 0";
 $rs = query($sql);
 while (list($key, $val) = each($rs["arr"])) {
 cmd_delete_event($val["id"]);
 }

 logcmd($W_DEL, $T_WORKFLOW, $id, 0, "cmd_delete_workflow");
}


function cmd_update_workflowlink($id, $name) {
 global $TIME, $USER_ID;
 
 $sql = "UPDATE workflowlink SET name = \"".sqlslashes($name)."\", editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME)." WHERE id = ".sqlf_tl_num($id);
 query($sql);
}



function cmd_link_workflow($id, $o_type, $o_id) {
 global $USER_ID, $TIME, $W_EDIT, $T_WORKFLOW;

 $sql = "SELECT name FROM workflow WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 
 $sql = "INSERT INTO workflowlink (workflow_id, name, o_type, o_id, creator, editor, cdate, edate) VALUES (".sqlf_tl_num($id).", \"".sqlslashes($rs["arr"][0]["name"])."\", ".sqlf_tl_num($o_type).", ".sqlf_tl_num($o_id).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($TIME).")";
 $rs = query($sql);
 $id = $rs["iid"];

 logcmd($W_EDIT, $T_WORKFLOW, $id, 0,"cmd_link_workflow: $o_type:$o_id");

 return $id;
}


function cmd_remove_workflowlink($id) {
 global $W_EDIT, $T_WORKFLOW;

 cmd_deactivate_workflowlink($id);
 $sql = "DELETE FROM workflowlink WHERE id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM reactionprop WHERE workflowlink_id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM eventprop WHERE workflowlink_id = ".sqlf_tl_num($id);
 query($sql);

 logcmd($W_EDIT, $T_WORKFLOW, $id, 0, "cmd_remove_workflowlink");
}


function cmd_activate_workflowlink($id, $type) {
 global $W_EDIT, $T_WORKFLOW, $W_OBJECT;

 $sql = "SELECT workflow_id FROM workflowlink WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $sql = "SELECT id FROM triggerevent WHERE templateevent_id = 0 AND reaction_id = 0 AND workflow_id = ".sqlf_tl_num($rs["arr"][0]["workflow_id"]);
 $rs = query($sql);
 while(list($key,$val) = each($rs["arr"])) {
 $sql = "SELECT keyword, value, info FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($val["id"]);
 $r = query($sql);
 $info = array();
 while (list($k,$v) = each($r["arr"])) {
 $info[$v["keyword"]]["val"] = $v["value"];
 $info[$v["keyword"]]["info"] = $v["info"];
 }
 
 $f = $W_OBJECT[$type]["get_trigger"];
 $trigger = $f($type,$info);
 cmd_activate_event($val["id"],$trigger,$id,-1);
 }

 logcmd($W_EDIT, $T_WORKFLOW, $id, 0, "cmd_activate_workflowlink");
}


function cmd_deactivate_workflowlink($id) {
 global $W_EDIT, $T_WORKFLOW;

 $sql = "SELECT id FROM triggerevent WHERE workflowlink_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "DELETE FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($val["id"]);
 query($sql);
 }
 $sql = "DELETE FROM triggerevent WHERE workflowlink_id = ".sqlf_tl_num($id);
 query($sql);

 logcmd($W_EDIT, $T_WORKFLOW, $id, 0, "cmd_deactivate_workflowlink");
}



function cmd_create_event($workflow_id, $name, $reaction_id = 0) {
 global $T_WORKFLOWEVENT, $W_CREATE;
 
 $sql = "INSERT INTO triggerevent (keyword, reaction_id, active, workflow_id, templateevent_id, workflowlink_id) ".
 "VALUES (\"".sqlslashes($name)."\", ".sqlf_tl_num($reaction_id).", 0, ".sqlf_tl_num($workflow_id).", 0, 0)";
 $rs = query($sql);
 $event_id = $rs["iid"];
 
 $sql = "SELECT workflowlink.id, count(triggerevent.id) as linkcount ".
 "FROM workflowlink ".
 "LEFT JOIN triggerevent ON triggerevent.workflowlink_id = workflowlink.id ".
 "AND triggerevent.templateevent_id > 0 ".
 "WHERE workflowlink.workflow_id = ".sqlf_tl_num($workflow_id)." ".
 "GROUP BY workflowlink.workflow_id";
 $rs = query($sql);
 foreach ( $rs["arr"] as $row )
 {
 if ( $row["linkcount"] ) 
 {
 cmd_activate_event($event_id, $name, $row["id"]);
 }
 }

 logcmd($W_CREATE, $T_WORKFLOWEVENT, $rs["iid"], $workflow_id, "cmd_create_event");
 
 return $event_id;
}


function cmd_delete_event($id) {
 global $T_WORKFLOWEVENT, $W_DEL;

 $sql = "DELETE FROM triggerevent WHERE id = ".sqlf_tl_num($id);
 query($sql);
 cmd_unset_eventprop($id, "", -1);
 $sql = "SELECT id FROM triggerevent WHERE templateevent_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 cmd_unset_eventprop($val["id"], "", -1);
 }
 $sql = "DELETE FROM triggerevent WHERE templateevent_id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "SELECT id FROM reaction WHERE triggerevent_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 cmd_delete_reaction($val["id"]);
 }

 logcmd($W_DEL, $T_WORKFLOWEVENT, $id, 0, "cmd_delete_event");
}


function cmd_set_eventprop($event_id, $key, $value, $info = "", $workflowlink_id = 0, $mapkey = "_set") {

 if ($mapkey == "_skip") { 
 cmd_unset_eventprop($event_id, $key, $workflowlink_id);
 return;
 }
 if ($mapkey == "_set") $mapkey = "";

 $sql = "SELECT id FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($event_id)." AND keyword = \"".sqlslashes($key)."\" AND workflowlink_id = ".sqlf_tl_num($workflowlink_id);
 $rs = query($sql);
 
 if ($rs["num"] > 0) {
 $sql = "UPDATE eventprop SET value = \"".sqlslashes($value)."\", info = \"".sqlslashes($info)."\", mapkey = \"".sqlslashes($mapkey)."\" WHERE triggerevent_id = ".sqlf_tl_num($event_id)." AND keyword = \"".sqlslashes($key)."\" AND workflowlink_id = ".sqlf_tl_num($workflowlink_id);
 query($sql);
 $id = $rs["arr"][0]["id"];
 } else {
 $sql = "INSERT INTO eventprop (triggerevent_id, keyword, value, info, mapkey, workflowlink_id) VALUES (".sqlf_tl_num($event_id).", \"".sqlslashes($key)."\",\"".sqlslashes($value)."\",\"".sqlslashes($info)."\", \"".sqlslashes($mapkey)."\", ".sqlf_tl_num($workflowlink_id).")";
 $rs = query($sql);
 $id = $rs["iid"];
 }
 return $id;
}


function cmd_unset_eventprop($event_id, $key = "", $workflowlink_id = 0) {
 if ($key) $sqlkey = "AND keyword = \"".sqlslashes($key)."\"";
 if ($workflowlink_id >= 0) $sqlkey .= " AND workflowlink_id = ".sqlf_tl_num($workflowlink_id);

 $sql = "SELECT id FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($event_id)." $sqlkey";
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row )
 {
 $sql = "DELETE FROM eventpropeditable WHERE eventprop_id=".sqlf_tl_num($row["id"]);
 query( $sql );
 }

 $sql = "DELETE FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($event_id)." $sqlkey";
 query($sql);
}

function cmd_event_set_editable($eventprop_id, $editable, $desc = "") {
 if ($editable) {
 $sql = "SELECT id FROM eventpropeditable WHERE eventprop_id = ".sqlf_tl_num($eventprop_id);
 $rs = query($sql);
 if ($rs["num"]) {
 $sql = "UPDATE eventpropeditable SET description = \"".sqlslashes($desc)."\" WHERE id = ".sqlf_tl_num($rs["arr"][0]["id"]);
 query($sql);
 } else {
 $sql = "INSERT INTO eventpropeditable (eventprop_id, description) VALUES (".sqlf_tl_num($eventprop_id).", \"".sqlslashes($desc)."\")";
 query($sql);
 }
 } else {
 $sql = "DELETE FROM eventpropeditable WHERE eventprop_id = ".sqlf_tl_num($eventprop_id);
 query($sql);
 }
}

function cmd_activate_event($id, $trigger, $workflowlink_id = -1, $status = -1) {
 $iid = false;
 $sql = "SELECT keyword, workflow_id, reaction_id, workflowlink_id FROM triggerevent WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $val = $rs["arr"][0];
 if ($workflowlink_id == -1 && $val["workflowlink_id"]) $workflowlink_id = $val["workflowlink_id"];
 $sql = "INSERT INTO triggerevent (keyword, workflow_id, workflowlink_id, reaction_id, active, templateevent_id) VALUES (\"".sqlslashes($val["keyword"])."\",".sqlf_tl_num($val["workflow_id"]).",".sqlf_tl_num($workflowlink_id).",".sqlf_tl_num($val["reaction_id"]).",".sqlf_tl_num($status).",".sqlf_tl_num($id).")";
 $rs = query($sql);
 $iid = $rs["iid"];

 $keys = get_event_trigger($id, $workflowlink_id, $trigger);
 reset($keys);
 while(list($k,$v) = each($keys)) {
 $sql = "INSERT INTO eventprop (keyword, value, info, triggerevent_id, workflowlink_id) VALUES (\"".sqlslashes($k)."\",\"".sqlslashes($v["val"])."\",\"".sqlslashes($v["info"])."\",".sqlf_tl_num($iid).",".sqlf_tl_num($workflowlink_id).")";
 query($sql);
 }
 }
 return $iid;
}

function cmd_create_reaction($workflow_id, $name, $event_id) {
 global $W_CREATE, $T_WORKFLOWREACTION;

 $sql = "INSERT INTO reaction (keyword, triggerevent_id, workflow_id) VALUES (\"".sqlslashes($name)."\",".sqlf_tl_num($event_id).", ".sqlf_tl_num($workflow_id).")";
 $rs = query($sql);

 logcmd($W_CREATE, $T_WORKFLOWREACTION, $rs["iid"], $workflow_id, "cmd_create_reaction");
 
 return $rs["iid"];
}

function cmd_delete_reaction($id) {
 global $W_DEL, $T_WORKFLOWREACTION;

 $sql = "DELETE FROM reaction WHERE id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "SELECT id FROM reactionprop WHERE reaction_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 foreach($rs["arr"] as $key=>$val) {
 $sql = "DELETE FROM reactionpropeditable WHERE reactionprop_id = ".sqlf_tl_num($val["id"]);
 query($sql);
 }
 $sql = "DELETE FROM reactionprop WHERE reaction_id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "SELECT id FROM triggerevent WHERE reaction_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 cmd_delete_event($val["id"]);
 }

 logcmd($W_DEL, $T_WORKFLOWREACTION, $id, 0, "cmd_delete_reaction");
 
}

function cmd_set_reactionprop($reaction_id, $key, $value, $workflowlink_id = 0, $mapkey = "_set") {

 if ($mapkey == "_skip") {
 cmd_unset_reactionprop($reaction_id, $key, $workflowlink_id);
 return;
 }
 if ($mapkey == "_set") $mapkey = "";

 $sql = "SELECT id FROM reactionprop WHERE keyword = \"".sqlslashes($key)."\" AND reaction_id = ".sqlf_tl_num($reaction_id)." AND workflowlink_id = ".sqlf_tl_num($workflowlink_id);
 $rs = query($sql);
 
 if ($rs["num"] > 0) {
 $sql = "UPDATE reactionprop ".
 "SET value = \"".sqlslashes($value)."\", mapkey = \"".sqlslashes($mapkey)."\" ".
 "WHERE keyword = \"".sqlslashes($key)."\" AND reaction_id = ".sqlf_tl_num($reaction_id)." ".
 "AND workflowlink_id=".sqlf_tl_num($workflowlink_id);
 query($sql);
 $id = $rs["arr"][0]["id"];
 } else {
 $sql = "INSERT INTO reactionprop (reaction_id, keyword, value, mapkey, workflowlink_id) ".
 "VALUES (".sqlf_tl_num($reaction_id).", \"".sqlslashes($key)."\", \"".sqlslashes($value)."\", ".
 "\"".sqlslashes($mapkey)."\", ".sqlf_tl_num($workflowlink_id).")";
 $rs = query($sql);
 $id = $rs["iid"];
 }
 return $id;
}

function cmd_unset_reactionprop($reaction_id, $key = "", $workflowlink_id = 0) {
 if ($key) $sqlkey = " AND keyword = \"".sqlslashes($key)."\"";
 $sql = "SELECT id FROM reactionprop WHERE reaction_id = ".sqlf_tl_num($reaction_id)." AND workflowlink_id = ".sqlf_tl_num($workflowlink_id)." $sqlkey";
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row )
 {
 $sql = "DELETE FROM reactionpropeditable WHERE reactionprop_id=".sqlf_tl_num($row["id"]);
 query( $sql );
 }
 $sql = "DELETE FROM reactionprop WHERE reaction_id = ".sqlf_tl_num($reaction_id)." AND workflowlink_id = ".sqlf_tl_num($workflowlink_id)." $sqlkey";
 query($sql);
}

function cmd_reaction_set_editable($reactionprop_id, $editable, $desc = "") {
 if ($editable) {
 $sql = "SELECT id FROM reactionpropeditable WHERE reactionprop_id = ".sqlf_tl_num($reactionprop_id);
 $rs = query($sql);

 if ($rs["num"]) {
 $sql = "UPDATE reactionpropeditable SET description = \"".sqlslashes($desc)."\" WHERE id = ".sqlf_tl_num($rs["arr"][0]["id"]);
 query($sql);
 } else {
 $sql = "INSERT INTO reactionpropeditable (reactionprop_id, description) VALUES (".sqlf_tl_num($reactionprop_id).", \"".sqlslashes($desc)."\")";
 query($sql);
 }
 } else {
 $sql = "DELETE FROM reactionpropeditable WHERE reactionprop_id = ".sqlf_tl_num($reactionprop_id);
 query($sql);
 }
}

?>
