<?

if ($cmd == 'update') {
 exit();
}

if ($maintenanceMode) {
?>
<script type="text/javascript">
	top.menu.location.reload();
	top.logo.location.reload();
	top.tree.location.reload();
</script>
<?
}
?>
<style type="text/css">
#guide {
	width: 200px;
	float: right;
	border-left: 1px dotted #97C2E2;
	padding: 0px 20px 10px 20px;
	margin-top: 100px;
}
#guide ol {
	padding-left: 18px;
}
#guide li {
	margin: 6px 0px;
}
#guide li a {
	display:block;
}
#guide li a:hover {
	background-color: #FFFFCC;
	text-decoration: underline;
}
#guide li.done {
	list-style-image: url(<?=$ICO_CHECK_ALL;?>);
}
#guide li.inprogress {
	list-style-image: url(<?=$ICO_AJAXLOAD;?>);
}
#guide img {
	margin-bottom: -2px;
}
#instantmessage {
	position: absolute;
	top: 18%;
	left: 30%;
	width: 300px;
	background-color: white;
	padding: 0px 15px;
	border: 1px solid #97C2E2;
	display: none;
}
#instantmessage textarea {
	width: 100%;
	height: 100px;
}
#manualChanges {
	font-weight: bold;
	display: none;
}
#logoutput, #logoutput * {
	font-family: Monospace;
	font-size: 12px;
}
#logoutput {
	margin: 10px 0px;
	padding: 10px;
	background-color: #EFEFEF;
}
.log_warn, .log_attn, .log_done {
	font-weight: bold;
}
.log_warn, .log_error {
	color: red;
}
.log_attn {
	color: #EF8100;
}
.log_done, .log_success {
	color: green;
}
.log_info {
	color: blue;
}
</style>
<?



if ($autoupdate->isRunUpdateFlagSet()) {
 $autoupdate->downloadFile($autoupdate->getSelectedUpdateFilename());
?>
<style>
.major, .manual {
	font-size: 14px;
}
.major {
	color: #FF8827;
}
.manual {
	color: red;
	background-image: url(<?=$ICO_ALERT_ANI;?>);
	background-repeat: no-repeat;
	padding-left: 22px;
}
.changelog {
	border: 0px dotted #97C2E2;
	border-width: 1px 0px;
	padding-right: 20%;
}
.changelog ul li {
	padding: 3px 0px;
	margin: 3px 0px;
}
.changelog a {
	color: #FF8827;
}
li.fix {
	list-style-image: url(<?=$STAG;?>&do=11&module=system&img=changelog-type-fix.gif);
}
li.new {
	list-style-image: url(<?=$STAG;?>&do=11&module=system&img=changelog-type-new.gif);
}
li.secu {
	list-style-image: url(<?=$STAG;?>&do=11&module=system&img=changelog-type-secu.gif);
}
li.var {
	list-style-image: url(<?=$STAG;?>&do=11&module=system&img=changelog-type-var.gif);
}
</style>
<script type="text/javascript">
function toggleConfirm() {
	var checked = jQuery("#confirm_changelog").attr("checked");
	if (checked == true) {
		jQuery("#install_update").attr("src", "?do=15&text=<?=urlencode(i18n("install_update"));?>");
		jQuery("#confirm_changelog_text").attr("style","color: green");
	} else {
		jQuery("#install_update").attr("src", "?do=15&text=<?=urlencode(i18n("install_update"));?>&disabled=true");
		jQuery("#confirm_changelog_text").attr("style","color: black");
	}
}
function triggerInstall() {
	var confirmed = jQuery("#confirm_changelog").attr("checked");
	if (confirmed) {
		location.href="<?=$STAG;?>&do=1040&updatefile=<?=$autoupdate->getSelectedUpdateFilename();?>&cmd=spawnupdate";
	} else {
		jQuery("#confirm_changelog_text").attr("style","color: red");
		alert("<?=i18n("confirm_changelog_error");?>");
	}
}
</script>
<div class="dialog">
	<h1>Changelog</h1>
	<p id="manualChanges">
		<img src="<?=$ICO_ALERT_ANI;?>" style="margin-bottom: -4px;" alt="<?=i18n("warning");?>" title="<?=i18n("warning");?>"/>
		<?=i18n("changelog_manual_changes_warn");?>
	</p>
	<p style="padding-bottom: 25px;">
		<?=i18n("changelog_further_info");?>
	</p>
	<p>
		<?= $autoupdate->getChangelogHTMLOutput($autoupdate->getSelectedUpdateFilename()); ?>
	</p>
<?
 if (!$clDisplayError) {
?>	
	<p id="confirm_changelog_text">
		<input type="checkbox" id="confirm_changelog" onclick="toggleConfirm();"><?=i18n("confirm_changelog");?>
	</p>
	<input id="install_update" type="image" border="0" alt="<?=i18n("install_update");?>" title="<?=i18n("install_update");?>" src="?do=15&amp;text=<?=urlencode(i18n("install_update"));?>&disabled=true" onclick="triggerInstall();"/>
<?
 }
?>
</div>
<? 
 return;
}

if ($cmd != 'updateprogress') {




?>
<script type="text/javascript">
GTXScheduler.init("<?=i18n("scheduler_status_running");?>", "<?=i18n("scheduler_status_suspending");?>", "<?=i18n("scheduler_status_suspended");?>", <?=(perm($USER_ID, T_TASKADMIN, "", 2)?"true":"false");?>);
</script>
<div id="instantmessage" class="shadow">
	<form method="post">
		<h3><?=i18n("instantmessage");?></h3>
		(<?=i18n("instantmessage_timeinfo");?>)
		<p><?=i18n("Recipient");?>: <select name="imto"><?
 $users = user_get_visibleuserswithname($USER_ID);
 while (list($k, $user) = each($users)) {
?><option value="<?=$k;?>"><?=$user["lastname"];?></option>
<? 
 }
 ?></select></p>
	
		<textarea name="msg"></textarea>
		<p>
			<input type="submit" name="im" value="<?=i18n("sn_message_send");?>">
			<input type="button" value="<?=i18n("cancel");?>" onClick="jQuery('#instantmessage').fadeOut('fast');">
		</p>
	</form>
</div>
<div id="guide">
	<h3><?=i18n("guide_pre_update");?></h3>
	<ol>
<?
if ($FEATURE["instantmessages"] && perm($USER_ID, T_INBOX, "", 2)) {
 
 $class = ($instantMessageSent) ? "done" : "";
?>
		<li class="<?=$class;?>"><a href="#" onClick="jQuery('#instantmessage').fadeIn('normal');"><img src="<?=$ICO_INBOX;?>" border="0"/> <?=i18n("send_instant_message");?></a></li>
<?
}
if ($FEATURE["maintenance_mode"] && perm($USER_ID, $T_MAINTENANCE, "", 1)) {
 $class = (getMaintenanceMode()) ? "done" : "";
?>
		<li class="<?=$class;?>"><a href="<?=$STAG;?>&do=1040&maintenanceMode=enable&instantMessageSent=<?=$instantMessageSent;?>"><img src="<?=$ICO_MAINTENANCE;?>" border="0"/> <?=i18n("activate_maintenance_mode");?></a></li>
<?
}
if (perm($USER_ID, $T_TASKADMIN, "", 2)) {
 $class = (Scheduler::getStatus() === SCHEDULER_STATUS_SUSPENDED) ? "done" : "";
?>
		<li id="guidesuspendscheduler" class="<?=$class;?>"><a href="#" onClick="jQuery(this).parent().attr('class', 'inprogress'); GTXScheduler.suspend();"><img src="<?=$ICO_TREEMENU;?>" border="0"/> <?=i18n("suspend_scheduler");?></a></li>
<?
}
?>
	</ol>
	<h3><?=i18n("guide_post_update");?></h3>
	<ol>
		<li class="<?=$class;?>"><a href="?do=7" target="_top" alt="<?= i18n("guide_selfupdate_logout_alt") ?>"><img src="<?= $ICO_LOGOUT; ?>" border="0"/><?= i18n("guide_selfupdate_logout")?>.</a></li>
	</ol>
</div>
<?
 
 echo $form->getHtmlOutput();
?>
<div class="dialog">
<?
 
 if ($showlog) {
 $logfileOuput = $autoupdate->getLogfileHTMLOutput($showlog);
?>
	<h1>Update Log <?=$showlog;?></h1>
	<input type="image" border="0" alt="<?=i18n("back");?>" title="<?=i18n("back");?>" src="?do=15&amp;text=<?=i18n("back");?>" onclick="location.href='<?=$STAG;?>&do=1040'"/>
	<div id="logoutput"><?=$logfileOuput;?></div>
	<input type="image" border="0" alt="<?=i18n("back");?>" title="<?=i18n("back");?>" src="?do=15&amp;text=<?=i18n("back");?>" onclick="location.href='<?=$STAG;?>&do=1040'"/>
<?
 } else {
 
?>
	<h1><?=i18n("Update History");?></h1>
	<?=$updatelog->getHTMLOutput();?>
<?
 }
?>
</div>
<?
} else {



?>
<style>
#updatestatus li {
	padding: 5px 0px 5px 22px;
	color: #788198;
	list-style-type: none;
}
#updatestatus .active,#updatestatus  .error {
	color: black;
	background-image: url(<?=$STAG;?>&do=11&module=system&img=ajax-load.gif);
	background-repeat: no-repeat;
	background-position: 0px 3px;
}
#updatestatus .error {
	color: red;
	background-image: url(<?=$ICO_ALERT_ANI;?>);
}
#updatestatus .done {
	color: black;
	background-image: url(<?=$STAG;?>&do=11&module=system&img=hackerl.gif);
	background-repeat: no-repeat;
	background-position: 0px 8px;
}
</style>
<div id="guide">
	<h3><?=i18n("guide_post_update");?></h3>
	<ol>
<?
if (perm($USER_ID, $T_TASKADMIN, "", 2)) {
$class = (Scheduler::getStatus() === SCHEDULER_STATUS_RUNNING) ? "done" : "";
?>
		<li id="guideresumescheduler" class="<?=$class;?>"><a href="#" onClick="GTXScheduler.resume();"><img src="<?=$ICO_TREEMENU;?>" border="0"/> <?=i18n("resume_scheduler");?></a></li>
<?
}
if ($FEATURE["maintenance_mode"] && perm($USER_ID, $T_MAINTENANCE, "", 1)) {
$class = (!getMaintenanceMode()) ? "done" : "";
?>
		<li class="<?=$class;?>"><a href="<?=$STAG;?>&do=1040&maintenanceMode=disable&cmd=updateprogress"><img src="<?=$ICO_MAINTENANCE;?>" border="0"/> <?=i18n("deactivate_maintenance_mode");?></a></li>
<?
}
?>
	</ol>
</div>
<div class="dialog">
	<h1>Update in Progress...</h1>
	<ul id="updatestatus">
		<li id="updatestatus_init"><?=i18n("updatestatus_init");?></li>
		<li id="updatestatus_extracting"><?=i18n("updatestatus_extracting");?></li>
		<li id="updatestatus_changelog"><?=i18n("updatestatus_changelog");?></li>
		<li id="updatestatus_update_nodecore"><?=i18n("updatestatus_update_nodecore");?></li>
		<li id="updatestatus_update_java"><?=i18n("updatestatus_update_java");?></li>
		<li id="updatestatus_restart_tomcat"><?=i18n("updatestatus_restart_tomcat");?></li>
		<li id="done"><?=i18n("done");?></li>
	</ul>
	<input type="image" border="0" alt="<?=i18n("back");?>" title="<?=i18n("back");?>" src="?do=15&amp;text=<?=i18n("back");?>" onclick="location.href='<?=$STAG;?>&do=1040'"/>
</div>
<script type="text/javascript">
GTXAutoUpdateStatus.init();
GTXScheduler.init("<?=i18n("scheduler_status_running");?>", "<?=i18n("scheduler_status_suspending");?>", "<?=i18n("scheduler_status_suspended");?>", <?=(perm($USER_ID, T_TASKADMIN, "", 2)?"true":"false");?>);
</script>
<? 
}
?>