<?

class BaseObject {

 var $outerClass;
 var $d_serializeKey;

 function BaseObject() {
 $this->outerClass = NULL;
 }

 



 function toString() {
 }

 function& _getClassVars()
 {
 $names = get_class_vars(get_class($this));
 $ret = array();
 foreach ( $names as $key=>$name )
 {
 $ret[$key] =& $this->$key;
 }
 return $ret;
 }
 
 function _setClassVars( &$vars )
 {
 foreach ( $vars as $key=>$var )
 {
 $this->$key =& $vars[$key];
 }
 }
 
 function _static_($set = FALSE)
 {
 static $statics = array();
 if ( isset( $statics[get_class($this)] ) )
 {
 $this->_setClassVars( $statics[get_class($this)] );
 return TRUE;
 }
 if ( $set )
 {
 $statics[get_class($this)] = &$this->_getClassVars();
 }
 return FALSE;
 }
 
 


 function setOuterClass(&$class) {
 $this->outerClass =& $class;
 }
 
 function &getOuterClass() {
 return $this->outerClass;
 }
 
 function __sleep() {
 $rs = $this->getSerializeKey();
 $ret = array();
 if ($rs == NULL) {
 $this->d_serializeKey = NULL;
 $vars = get_object_vars($this);
 foreach($vars as $var=>$val) { $ret[] = $var; }
 } else {
 $this->d_serializeKey= $rs;
 $ret = array("d_serializeKey");
 }
 return $ret;
 }

 function __wakeup() {
 $this->initFromSerializeKey($this->d_serializeKey);
 }
 
 






 function getSerializeKey() { }

 





 function initFromSerializeKey( $key ) { }
 
}




class NodeObject extends BaseObject {

 


 function NodeObject( $id = 0 ) {
 parent::BaseObject();
 }
 
 


 function getTType() {}

 


 function getID() {}
 
 function setID( $id ) {}
 
 function getIcon() {}
 
 function getKey() { return $this->getID(); }

 






 function getPropertyNames() 
 {
 return array( "type"=>i18n("Type"), "id"=>i18n("ID") ); 
 }
 
 




 function getProperty( $key ) {
 switch ( $key ) {
 case "type":
 $class = new StringObject($this->getTType());
 break;
 case "id":
 $class = new StringObject($this->getID());
 break;
 default:
 $class = new NodeException("NodeObject: Property ($key) not defined.");
 }
 return $class;
 }
 
 function toString()
 {
 return "Type = ".$this->getTType().", ID = ".$this->getID();
 }
 
 












 function onEventNotify( $TType, $id, $changeType, $linkType, $eventObject, $depth ) {}

 











 function onStaticEventNotify( $TType, $id, $changeType, $eventObject, $depth ) {}
}

class StringObject extends BaseObject {

 var $d_string;

 function StringObject($string = "") {
 parent::BaseObject();
 $this->d_string = $string;
 }

 function setString($string) {
 $this->d_string = $string;
 }

 function getString() {
 return $this->d_string;
 }

 function toString() {
 return $this->d_string;
 }

}

class EMessage extends BaseObject {

 var $d_message;

 function EMessage($message = "", $nestedMessage = NULL) {
 parent::BaseObject();
 $this->d_message = $message;
 }

 function getMessage() {
 return $this->d_message;
 }

 function toString() {
 return $this->d_message;
 }

}

class NodeException extends EMessage {
 
 function NodeException($exception = "", $nestedException = NULL) {
 parent::EMessage($exception, $nestedException);
 }
}

class EWarning extends EMessage {

 function EWarning($warning = "", $nestedWarning = NULL) {
 parent::EMessage($warning, $nestedWarning);
 }
}

?>
