<?








function createTaskTemplate($name, $command, $description, $params) {
 $name = addslashes($name);
 $command = addslashes($command);
 $description = addslashes($description);

 
 $sql = "select id from tasktemplate where name = '$name'";
 $rs = query($sql);

 if ( $rs["num"] > 0 ) {
 echo "could not create tasktemplate with name '$name', as there is already a tasktemplate with that name. id: " . $rs["arr"][0]["id"] . "\n";
 exit(1);
 return false;
 }

 $sql = "insert into tasktemplate (name, description, command, editor, edate, creator, cdate) values ('$name', '$description', '$command', 1, ".time().", 1, ".time().")";
 $rs = query($sql);
 $tid = $rs["iid"];

 
 foreach ( $params as $key => $value ) {
 $sql = "insert into tasktemplateparam (tasktemplate_id, paramtype, name) values ($tid, 3, '".addslashes($value)."')";
 query($sql);
 }

 return $tid;
}







function createTask($templateId, $name, $params) {
 if (!$templateId) {
 return false;
 }
 $name = addslashes($name);

 
 $sql = "select id from task where name = '$name'";
 $rs = query($sql);

 if ( $rs["num"] > 0 ) {
 echo "could not create task with name '$name', as there is already a task with that name. id: " . $rs["arr"][0]["id"] . "\n";
 exit(1);
 return false;
 }

 
 $sql = "insert into task (name, tasktemplate_id, editor, edate, creator, cdate) values ('$name', $templateId, 1, ".time().", 1, ".time().")";
 $rs = query($sql);
 $taskId = $rs["iid"];

 
 $sql = "select id, name from tasktemplateparam where tasktemplate_id = $templateId";
 $rs = query($sql);

 foreach ($rs["arr"] as $row) {
 $value = $params[$row["name"]];
 $sql = "insert into taskparam (task_id, templateparam_id, name, value) values ($taskId, ".$row["id"].", 't', '".addslashes($value)."')";
 query($sql);
 }

 return $taskId;
}











function createJob($taskId, $name, $description, $parallel = false, $status = 0, $scheduleType = 'manual', $scheduleData = false) {
 if (!$taskId) {
 return false;
 }
 $name = addslashes($name);
 $description = addslashes($description);

 
 $sql = "select id from job where name = '$name'";
 $rs = query($sql);

 if ( $rs["num"] > 0 ) {
 echo "could not create job with name '$name', as there is already a job with that name. id: " . $rs["arr"][0]["id"] . "\n";
 exit(1);
 return false;
 }

 if ( !$scheduleData ) {
 $scheduleData = addslashes(serialize(array("s" => serialize(false))));
 }
 $sql = "insert into job (name, description, task_id, schedule_type, schedule_data, cdate, creator, edate, editor, parallel, status) " . 
 "values ('$name', '$description', $taskId, '$scheduleType', '" . $scheduleData . "', ".time().", 1, ".time().", 1, ".($parallel ? 1 : 0).", $status)";
 $rs = query($sql);

 return $rs["iid"];
}

?>
