<?
class AllPagesSearcher extends CNPageObject {

 function AllPagesSearcher($buildid) {
 $this->buildid = $buildid;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 global $CONTENTGROUP_ID;

 $searchsql = " AND page.id IN (SELECT obj_id FROM bundlecontainedobject WHERE obj_type = 10007 AND referrer_obj_id = 0 AND referrer_obj_type = 0 AND bundlebuild_id = ".sqlf_tl_num($this->buildid).")";
 if ($searchterm) {
 $searchsql .= " AND (LOWER(page.name) LIKE '%" . sqlslashes($searchterm) . "%') ";
 }

 $pages = get_pages(false, $CONTENTGROUP_ID, '', false, $searchsql, array(), false, 0, 0, false);
 $objects =& $this->_processResultset(array("arr"=>$pages));
 $this->getFolderPaths(&$objects);
 return $objects;
 }
}

class AllFoldersSearcher extends CNFolderObject {
 function AllFoldersSearcher($buildid) {
 $this->buildid = $buildid;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 $sql = "SELECT " . $this->_getNodeTable() . ".* " .
 "FROM " . $this->_getSearchTable() . " " .
 "WHERE folder.id IN (SELECT obj_id FROM bundlecontainedobject WHERE obj_type = 10002 AND referrer_obj_id = 0 AND referrer_obj_type = 0 AND bundlebuild_id = ".sqlf_tl_num($this->buildid).")";
 $baseFilter = $this->_getBaseFilter();
 $searchFilter = $this->_getSearchFilter($searchterm);
 if ($baseFilter) {
 $sql .= " AND " . $baseFilter;
 }
 if ($searchFilter) {
 $sql .= " AND " . $searchFilter;
 }
 $sql .= " GROUP BY " . $this->_getNodeTable() . ".id";
 $rs = query($sql);
 $objects =& $this->_processResultSet($rs);
 $this->getFolderPaths(&$objects);
 return $objects;
 }
}

class AllTemplatesSearcher extends CNTemplateObject {
 function AllTemplatesSearcher($buildid) {
 $this->buildid = $buildid;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 $sql = "SELECT " . $this->_getNodeTable() . ".* " .
 "FROM " . $this->_getSearchTable() . " " .
 "WHERE template.id IN (SELECT obj_id FROM bundlecontainedobject WHERE obj_type = 10006 AND referrer_obj_id = 0 AND referrer_obj_type = 0 AND bundlebuild_id = ".sqlf_tl_num($this->buildid).")";
 $baseFilter = $this->_getBaseFilter();
 $searchFilter = $this->_getSearchFilter($searchterm);
 if ($baseFilter) {
 $sql .= " AND " . $baseFilter;
 }
 if ($searchFilter) {
 $sql .= " AND " . $searchFilter;
 }
 $sql .= " GROUP BY " . $this->_getNodeTable() . ".id";
 $rs = query($sql);
 return $this->_processResultSet($rs);
 }
}

class AllFilesSearcher extends CNFileObject {
 function AllFilesSearcher($buildid) {
 $this->buildid = $buildid;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 $searchsql = " AND contentfile.id IN (SELECT obj_id FROM bundlecontainedobject WHERE obj_type = 10008 AND referrer_obj_id = 0 AND referrer_obj_type = 0 AND bundlebuild_id = ".sqlf_tl_num($this->buildid).")";
 if ($searchterm) {
 $searchsql .= " AND " . $this->_getSearchFilter($searchterm);
 }
 $files = get_files(false, false, $searchsql, array(), false);
 $objects =& $this->_processResultset(array("arr"=>$files));
 $this->getFolderPaths(&$objects);
 return $objects;
 }
}

class AllImagesSearcher extends CNImageObject {
 function AllImagesSearcher($buildid) {
 $this->buildid = $buildid;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 $searchsql = " AND contentfile.id IN (SELECT obj_id FROM bundlecontainedobject WHERE obj_type = 10011 AND referrer_obj_id = 0 AND referrer_obj_type = 0 AND bundlebuild_id = ".sqlf_tl_num($this->buildid).")";
 if ($searchterm) {
 $searchsql .= " AND " . $this->_getSearchFilter($searchterm);
 }
 $files = get_images(false, false, $searchsql, array(), false);
 $objects =& $this->_processResultset(array("arr"=>$files));
 $this->getFolderPaths(&$objects);
 return $objects;
 }
}

?>