<?






function verifyEditInherited($obj_type, $obj_id, $channel_id) {
 global $VERIFIED_EDIT_INHERITED;

 
 mysession_var_reg('VERIFIED_EDIT_INHERITED');
 $VERIFIED_EDIT_INHERITED = array('obj_type' => $obj_type, 'obj_id' => $obj_id, 'channel_id' => $channel_id);
}








function isEditInheritedVerified($obj_type, $obj_id, $channel_id) {
 global $VERIFIED_EDIT_INHERITED;

 if (!is_array($VERIFIED_EDIT_INHERITED)) {
 return false;
 }

 return $VERIFIED_EDIT_INHERITED['obj_type'] == $obj_type
 && $VERIFIED_EDIT_INHERITED['obj_id'] == $obj_id
 && $VERIFIED_EDIT_INHERITED['channel_id'] == $channel_id;
}





function localizeAndEdit(&$form) {
 global $NODE_ID, $REDO;

 
 $obj_type_comp = &$form->resolveComponent("main.obj_type");
 $obj_type = $obj_type_comp->getValue();
 $obj_id_comp = &$form->resolveComponent("main.obj_id");
 $obj_id = $obj_id_comp->getValue();
 $do_cancel_comp = &$form->resolveComponent("main.do_cancel");
 $do_cancel = $do_cancel_comp->getValue();
 $do_edit_comp = &$form->resolveComponent("main.do_edit");
 $do_edit = $do_edit_comp->getValue();
 $obj_id_param_comp = &$form->resolveComponent("main.obj_id_param");
 $obj_id_param = $obj_id_param_comp->getValue();
 $do_params_comp = &$form->resolveComponent("main.do_params");
 $do_params = $do_params_comp->getValue();

 
 $javaParser =& CodeParser::getJavaParser();
 $rs = $javaParser->localizeObject($obj_type, $obj_id, $NODE_ID, true);

 
 $loc_id = getLocalizedObject($obj_type, $obj_id, $NODE_ID);

 
 if (!$loc_id) {
 $REDO = $do_cancel;
 } else {
 global $$obj_id_param;
 $$obj_id_param = $loc_id;
 $REDO = $do_edit;

 if (is_array($do_params)) {
 reset($do_params);
 while (list($key, $val) = each($do_params)) {
 global $$key;
 $$key = $val;
 }
 }
 }
}










function getLocalizedObject($obj_type, $master_id, $channel_id) {
 switch($obj_type) {
 case T_PAGE:
 $sql = "SELECT id FROM page WHERE channelset_id = (SELECT channelset_id FROM page WHERE id = ".sqlf_tl_num($master_id).") and channel_id = ".sqlf_tl_num($channel_id);
 break;
 case T_TEMPLATE:
 $sql = "SELECT id FROM template WHERE channelset_id = (SELECT channelset_id FROM template WHERE id = ".sqlf_tl_num($master_id).") and channel_id = ".sqlf_tl_num($channel_id);
 break;
 case CT_FILE:
 case T_IMAGE:
 $sql = "SELECT id FROM contentfile WHERE channelset_id = (SELECT channelset_id FROM contentfile WHERE id = ".sqlf_tl_num($master_id).") and channel_id = ".sqlf_tl_num($channel_id);
 break;
 default:
 return false;
 }

 $rs = query($sql);
 if ($rs["num"] == 0) {
 return false;
 } else {
 return $rs["arr"][0]["id"];
 }
}





function editInherited(&$form) {
 global $REDO, $VERIFIED_EDIT_INHERITED, $NODE_ID;

 $do_edit_comp = &$form->resolveComponent("main.do_edit");
 $do_edit = $do_edit_comp->getValue();

 $obj_type_comp = &$form->resolveComponent("main.obj_type");
 $obj_type = $obj_type_comp->getValue();

 $obj_id_comp = &$form->resolveComponent("main.obj_id");
 $obj_id = $obj_id_comp->getValue();

 $obj_id_param_comp = &$form->resolveComponent("main.obj_id_param");
 $obj_id_param = $obj_id_param_comp->getValue();

 $do_params_comp = &$form->resolveComponent("main.do_params");
 $do_params = $do_params_comp->getValue();

 global $$obj_id_param;
 $$obj_id_param = $obj_id;

 $REDO = $do_edit;

 verifyEditInherited($obj_type, $obj_id, $NODE_ID);

 if (is_array($do_params)) {
 reset($do_params);
 while (list($key, $val) = each($do_params)) {
 global $$key;
 $$key = $val;
 }
 }
}
?>