<?
node_class("codeparser");

function doMoveCommand($table, $ttype = false) {
 global $cmd, $moveid;

 $table = sqlf_table($table);
 if( $cmd == 'movedown' || $cmd == 'moveup' ) {
 if ($ttype) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->bufferClearCaches(true);
 }
 $sql = "SELECT id, sortorder FROM $table ORDER BY sortorder";
 $rs = query( $sql );
 for( $i = 0 ; $i < count($rs['arr']) ; $i++ ) {
 $curr = $rs['arr'][$i];
 $next = $rs['arr'][$i+1];
 if ( $cmd == 'moveup' && $next['id'] == $moveid ) {
 $sql = "UPDATE $table SET sortorder = '".($i)."' WHERE id = '".sqlf_escaped($next['id'])."'";
 query( $sql );
 if ($ttype) {
 $javaParser->clearCache($ttype, $next['id']);
 }
 $sql = "UPDATE $table SET sortorder = '".($i+1)."' WHERE id = '".sqlf_escaped($curr['id'])."'";
 query( $sql );
 if ($ttype) {
 $javaParser->clearCache($ttype, $curr['id']);
 }
 } else if( $cmd == 'movedown' && $curr['id'] == $moveid ) {
 $sql = "UPDATE $table SET sortorder = '".($i)."' WHERE id = '".sqlf_escaped($next['id'])."'";
 query( $sql );
 if ($ttype) {
 $javaParser->clearCache($ttype, $next['id']);
 }
 $sql = "UPDATE $table SET sortorder = '".($i+1)."' WHERE id = '".sqlf_escaped($curr['id'])."'";
 query( $sql );
 if ($ttype) {
 $javaParser->clearCache($ttype, $curr['id']);
 }
 } else if( $curr['id'] != $moveid && $next['id'] != $moveid && $curr['sortorder'] != $i ) {
 $sql = "UPDATE $table SET sortorder = '$i' WHERE id = '".sqlf_escaped($curr['id'])."'";
 query( $sql );
 if ($ttype) {
 $javaParser->clearCache($ttype, $curr['id']);
 }
 }
 }
 if ($ttype) {
 $javaParser->bufferClearCaches(false);
 }
 }
}


class SortOrderFormatter extends ResultsetFormatter {
 function SortOrderFormatter() {
 }
 function format( $row ) {
 global $STAG, $STAG_PREFIX, $DO, $maxsortorder, $minsortorder;
 if( $row['sortorder'] <= $minsortorder && $row['sortorder'] >= $maxsortorder ) return '';
 return 
 ($row['sortorder'] > $minsortorder ? " <a href='$STAG&do=$DO&cmd=moveup&moveid=".$row['id']."'>".img( $STAG_PREFIX.'?do=11&module=system&img=point_up.gif', 0, i18n( 'Up' ) )."</a>" : img(false, 0, '', '', '20px', '20px' ) ) .
 
 ($row['sortorder'] < $maxsortorder ? "<a href='$STAG&do=$DO&cmd=movedown&moveid=".$row['id']."'>".img( $STAG_PREFIX.'?do=11&module=system&img=point_down.gif', 0, i18n( 'Down' ) )."</a>" : '');
 }
}

?>